@import "@assets/themes/themify.utils.scss";
@import "~/themes.scss";

.InputText-normal,
.InputText-large {
  display: block !important;

  &:hover,
  &:focus-within {
    outline: transparent;
  }

  &-disabled,
  &-disabled:hover {
    border-radius: 0;

    &,
    * {
      cursor: not-allowed;
    }
  }

  &:hover,
  &:focus-within {
    outline: transparent;
  }

  input {
    all: unset;
    width: 100%;
    height: 100%;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }
}

.InputText-normal {
  height: 2.25rem;
  font-size: 0.8rem;
  text-rendering: optimizelegibility;
  border: 2px solid;
  border-radius: 0.25rem;
  padding: 0.25rem 0.5rem;

  .InputTextAddon {
    height: 1.25rem;
    width: 1.25rem;
    margin: 1px 8px 0 0 !important;
    transform: translateY(40%);
  }

  input {
    transform: translateY(50%);
  }

  input::placeholder {
    opacity: 1;
  }
}

.InputText-large {
  height: 3.5rem;
  font-size: 1rem;
  text-rendering: optimizelegibility;
  border-bottom: 2px solid #c7c7c7 !important;
  border-radius: 0.25rem 0.25rem 0 0;
  padding: 0.25rem 0.5rem 0 1.2rem;

  .InputTextAddon {
    display: inline-block;
    height: 1.5rem;
    width: 1.5rem;
    margin: 1px 8px 0 0 !important;
  }

  &:focus-within {
    caret-color: #547aff;
  }

  input::placeholder {
    opacity: 0.7;
  }
}

.InputText-normal-simon {
  height: 1.6rem;
  font-size: 0.8rem;

  .InputTextAddon {
    transform: translateY(10%);
  }

  input {
    transform: translateY(32%);
  }
}

@include themify("InputText", $themes) {
  font-family: themed("font-family");
  color: themed("field-text");
  background-color: themed("field-background-editable");
  border-color: themed("field-background-editable");

  &.InputText {
    &-disabled,
    &-disabled:hover {
      color: themed("field-text-disabled");
      background-color: themed("field-background-disabled");
      border-color: themed("field-background-disabled");
    }

    &-danger {
      border-color: themed("field-danger") !important;
      caret-color: themed("field-danger");

      &:hover,
      &:focus-within {
        label {
          color: themed("field-danger");
        }
      }

      svg {
        color: themed("field-danger") !important;
      }
    }

    &-busy {
      border-color: themed("field-busy") !important;
      caret-color: themed("field-busy");

      &:hover,
      &:focus-within {
        label {
          color: themed("field-busy");
        }
      }

      svg {
        color: themed("field-busy") !important;
      }
    }
  }

  &:hover,
  &:focus-within {
    border-color: themed("field-focused");

    label {
      color: themed("field-focused");
    }
  }

  input::placeholder {
    color: themed("field-text-placeholder");
  }

  label {
    color: themed("field-label");
    font-size: 12px;
    padding-bottom: 2px;
  }

  /* Change Autocomplete styles in Chrome*/
  input:-webkit-autofill,
  input:-webkit-autofill:hover,
  input:-webkit-autofill:focus {
    -webkit-text-fill-color: themed("field-text");
    -webkit-box-shadow: 0 0 0px 1000px themed("field-background-editable") inset;
    transition: themed("field-background-editable") 5000s ease-in-out 0s;
  }
}
